// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	v1alpha1 "github.com/karmada-io/karmada/pkg/apis/policy/v1alpha1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakePropagationWorks implements PropagationWorkInterface
type FakePropagationWorks struct {
	Fake *FakePolicyV1alpha1
	ns   string
}

var propagationworksResource = schema.GroupVersionResource{Group: "policy.karmada.io", Version: "v1alpha1", Resource: "propagationworks"}

var propagationworksKind = schema.GroupVersionKind{Group: "policy.karmada.io", Version: "v1alpha1", Kind: "PropagationWork"}

// Get takes name of the propagationWork, and returns the corresponding propagationWork object, and an error if there is any.
func (c *FakePropagationWorks) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1alpha1.PropagationWork, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(propagationworksResource, c.ns, name), &v1alpha1.PropagationWork{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.PropagationWork), err
}

// List takes label and field selectors, and returns the list of PropagationWorks that match those selectors.
func (c *FakePropagationWorks) List(ctx context.Context, opts v1.ListOptions) (result *v1alpha1.PropagationWorkList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(propagationworksResource, propagationworksKind, c.ns, opts), &v1alpha1.PropagationWorkList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1alpha1.PropagationWorkList{ListMeta: obj.(*v1alpha1.PropagationWorkList).ListMeta}
	for _, item := range obj.(*v1alpha1.PropagationWorkList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested propagationWorks.
func (c *FakePropagationWorks) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(propagationworksResource, c.ns, opts))

}

// Create takes the representation of a propagationWork and creates it.  Returns the server's representation of the propagationWork, and an error, if there is any.
func (c *FakePropagationWorks) Create(ctx context.Context, propagationWork *v1alpha1.PropagationWork, opts v1.CreateOptions) (result *v1alpha1.PropagationWork, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(propagationworksResource, c.ns, propagationWork), &v1alpha1.PropagationWork{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.PropagationWork), err
}

// Update takes the representation of a propagationWork and updates it. Returns the server's representation of the propagationWork, and an error, if there is any.
func (c *FakePropagationWorks) Update(ctx context.Context, propagationWork *v1alpha1.PropagationWork, opts v1.UpdateOptions) (result *v1alpha1.PropagationWork, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(propagationworksResource, c.ns, propagationWork), &v1alpha1.PropagationWork{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.PropagationWork), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakePropagationWorks) UpdateStatus(ctx context.Context, propagationWork *v1alpha1.PropagationWork, opts v1.UpdateOptions) (*v1alpha1.PropagationWork, error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateSubresourceAction(propagationworksResource, "status", c.ns, propagationWork), &v1alpha1.PropagationWork{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.PropagationWork), err
}

// Delete takes name of the propagationWork and deletes it. Returns an error if one occurs.
func (c *FakePropagationWorks) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteAction(propagationworksResource, c.ns, name), &v1alpha1.PropagationWork{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakePropagationWorks) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(propagationworksResource, c.ns, listOpts)

	_, err := c.Fake.Invokes(action, &v1alpha1.PropagationWorkList{})
	return err
}

// Patch applies the patch and returns the patched propagationWork.
func (c *FakePropagationWorks) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.PropagationWork, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(propagationworksResource, c.ns, name, pt, data, subresources...), &v1alpha1.PropagationWork{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.PropagationWork), err
}
